/*
 * Copyright (c) 2016-2017 Illumon and Patent Pending
 */

#pragma once

// The CountArgs structure returns the number of elements in Args..

template<typename... Args>
struct CountArgs;

template <>
struct CountArgs<>
{
  static const size_t value = 0;
};

template<typename First, typename... Rest>
struct CountArgs<First, Rest...>
{
  static const size_t value = 1 + CountArgs<Rest...>::value;
};

