/*
 * Copyright (c) 2016-2017 Illumon and Patent Pending
 */

#pragma once

// an errno_exception is a runtime exception that contains an errno and sets
// its what to the string error message passed in, plus the string
// representation of the errno.

#include <string>
#include <cerrno>
#include <cstring>
#include <stdexcept>

namespace illumon { namespace util {

class errno_exception : public std::runtime_error
{
public:
  errno_exception(std::string const & what, int errnum) 
    : std::runtime_error(what + ": " + std::string(strerror(errnum)))
    , m_errno(errnum)
  {
  }

  int getErrno() const
  {
    return m_errno;
  }

private:
  int m_errno;
};

}}
